       program main
       implicit complex (c)

C----   This is just an example how to calculate
C----   amplitude for a transition from channel 'i' to channel 'j'
C----   A_(ij)=K_{ik}(I-i rho K)^-1_{kj}

      character*8 name
      character*1 name_n
      
      common/cmpln/wim,k8
      COMMON/COMP/CI
      common/a0980com/g1,g2,am980
      open(32,file='t11.dat',status='unknown')
      ci=cmplx(0.,1.)
      am0=0.70
      h=0.001
      amf=1.3
      wk=0.4973
      em=0.5488 
      pm=0.13496
      k8=1
      wim=0.
      n=201
      h=(amf-am0)/(n-1)

      am980=0.986
      am980=1.05
      g1=0.20
      g2=0.
c      print *,'M=?'
c      read  *, am980 
c      print *,'g1=?'
c      read  *, g1   
      print *,'g2=?'
      read  *, g2
      print *,'variant N=?'
      read  *, name_n
      
      name='a0_'//name_n//'.dat'

      open(31,file=name,status='unknown')
      do i=1,n+1
      am=am0+h*(i-1)
      s=am*am
      c1=1./ca0_980(s)
      cc1=abs(c1*g1*cro(s,em,pm))**2
      cc2=abs(c1)**2*cro(s,em,pm)*cro(s,wk,wk)*g1*g2
      write(31,100)am,cc1,cc2
      enddo
100   format(f8.4,3(2E12.4,3x))
      close(31)
      
      call poles
      
      stop
      end
************************************************************************
C----Subroutine  Poles for  ------------
      subroutine poles
      implicit complex (c)
      character*4 flag
      common/cmpln/wim,k8
      common/alxx/al
      DIMENSION X(10),ANRE(5000,2),ANIM(5000,2)
      ci=cmplx(0.,1.)
      n_im=101
      wn=0.001                  ! - high boundary for Im(M)
      wfin=-0.30                ! - low  boundary for Im(M)
      st=0.70                   ! - low  boundary for Re(M)
      sk=1.3                    ! - high boundary for Re(M)
      nn3=201
      al=1.0
      s_in=st
      s_fin=sk
      print *,'n_im=',n_im
      close(1)
      h1=(wfin-wn)/(n_im-1)
      open(4,file='deti.dat',status='unknown')
      k8_max=2                          !  number of sheets considered
      DO 44 K8=1,k8_max
      L4=0
      L5=0
      DO 4 I=1,n_im
      WID=H1*(I-1)+wn
c      H=(SK-ST)/(nn3-1)
      H=(S_fin-S_in)/(nn3-1)
      LR=0
      do 4 J=1,nn3
      AM=S_in+H*(J-1)+0.00001
      cam=cmplx(am,wid)
      c=cam**2
c      c=cmplx(am,wid)
      s=real(c)
      wim=aimag(c)
      cxx=0.
      cxx=ca0_980(s)
      dre=real(cxx)
      dim=aimag(cxx)
      IF(J.GE.2) THEN
      Q5=DRE*DRT
      IF(Q5.LE.0.) THEN
      L4=L4+1
      ANRE(L4,1)=AM-DRE*H/(DRE-DRT)
      ANRE(L4,2)=WID
      ENDIF
      Q5=DIM*DIT
      IF(Q5.LE.0.) THEN
      L5=L5+1
      ANIM(L5,1)=AM-DIM*H/(DIM-DIT)
      ANIM(L5,2)=WID
      ENDIF
      ENDIF
      DRT=DRE
      DIT=DIM
    4 continue
      IF(K8.EQ.1) then
      OPEN(3,FILE='det1.dat',STATUS='unknown')
      endif
      IF(K8.EQ.2) then
      OPEN(3,FILE='det3.dat',STATUS='unknown')
      endif
      write(4,300) L4
      WRITE(3,105)((ANRE(I,J),J=1,2),I=1,L4)
      PRINT *,'L=',L4
      CLOSE(3)
      IF(K8.EQ.1) then
      OPEN(3,FILE='det2.dat',STATUS='unknown')
      endif
      IF(K8.EQ.2) then
      OPEN(3,FILE='det4.dat',STATUS='unknown')
      endif
      write(4,300) L5
300   format(i6)
      WRITE(3,105)((ANIM(I,J),J=1,2),I=1,L5)
      PRINT *,'L=',L5
      CLOSE(3)
   44 CONTINUE
      CLOSE(4)
  105 FORMAT(2X,2E16.4)
      return
      END

C*************************************************
c      azero(980) AMPLITUDE
      COMPLEX FUNCTION CA0_980(s)
      IMPLICIT COMPLEX (C)
      common/cmpln/wim,k8
      COMMON/COMP/CI
      common/a0980com/g1,g2,am
      c=cmplx(s,wim)
      wk=0.4973      
      em=0.5488 
      pm=0.13496
c      crho1=sqrt((c-(em+pm)**2)*(c-(em-pm)**2))/c
      crho1=1.
      crho2=sqrt((c-4.*wk**2)/c)
      if(k8.eq.2) crho2=ci*sqrt((4.*wk**2-c)/c)
      ca0_980=(c-am**2+ci*(g1*crho1+g2*crho2))
      return
      end
C----------------------------------------------------------
C       CALCULATION OF TWO PARTICLE PHASE VOLUME
      COMPLEX FUNCTION CRO(S,AM1,AM2)
      IMPLICIT COMPLEX (C)
      COMMON/COMP/CI
      T1=(AM1+AM2)**2
      T2=(AM1-AM2)**2
      ST=(S-T1)*(S-T2)
      CRO=SQRT(ABS(ST))/S
      IF(ST.LT.0.) CRO=CRO*CI
      RETURN
      END
